/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __maya_SurfaceAccessibleMaya_h__
#define __maya_SurfaceAccessibleMaya_h__

namespace fe
{

/**************************************************************************//**
    @brief Maya Surface Binding

	@ingroup maya
*//***************************************************************************/
class FE_DL_EXPORT SurfaceAccessibleMaya:
	public SurfaceAccessibleBase
{
	public:
								SurfaceAccessibleMaya(void)					{}
virtual							~SurfaceAccessibleMaya(void)				{}

								//* as SurfaceAccessibleI
virtual sp<SurfaceAccessorI>	accessor(SurfaceAccessibleI::Element a_element,
										String a_name,
										SurfaceAccessibleI::Creation a_create)
								{
									sp<SurfaceAccessorMaya> spAccessor(
											new SurfaceAccessorMaya);
									spAccessor->setMaster(registry()->master());
									spAccessor->setMeshObject(
											m_meshData.asMesh());
									if(spAccessor->bind(a_element,a_name) ||
											a_create==
											SurfaceAccessibleI::e_createMissing)
									{
										spAccessor->setSurfaceAccessible(
												sp<SurfaceAccessibleI>(this));
										return spAccessor;
									}
									return sp<SurfaceAccessorI>(NULL);
								}

virtual sp<SurfaceAccessorI>	accessor(SurfaceAccessibleI::Element a_element,
										SurfaceAccessibleI::Attribute
										a_attribute,
										SurfaceAccessibleI::Creation a_create)
								{
									sp<SurfaceAccessorMaya> spAccessor(
											new SurfaceAccessorMaya);
									spAccessor->setMaster(registry()->master());
									spAccessor->setMeshObject(
											m_meshData.asMesh());
									if(spAccessor->bind(a_element,a_attribute)
											|| a_create==
											SurfaceAccessibleI::e_createMissing)
									{
										spAccessor->setSurfaceAccessible(
												sp<SurfaceAccessibleI>(this));
										return spAccessor;
									}
									return sp<SurfaceAccessorI>(NULL);
								}

virtual	sp<SurfaceI>			surface(void)	{ return m_spSurfaceI; }
virtual	sp<SurfaceI>			subSurface(U32 a_subIndex)
								{
									//* TODO
									return sp<SurfaceI>(NULL);
								}

virtual	void					append(sp<SurfaceAccessibleI>
										a_spSurfaceAccessibleI,
										SpatialTransform& a_rTransform);

virtual	void					instance(sp<SurfaceAccessibleI>
										a_spSurfaceAccessibleI,
										std::vector<SpatialTransform>&
										a_rTransformArray);

								//* Maya specific
		void					setMeshData(const MDataHandle a_meshData)
								{
									m_meshData=a_meshData;

									m_spSurfaceI=registry()->create(
											"SurfaceI.SurfaceTrianglesMaya");
									if(m_spSurfaceI.isValid())
									{
										sp<SurfaceTrianglesMaya> spSurface=
												m_spSurfaceI;
										if(spSurface.isValid())
										{
											spSurface->setMeshObject(
													m_meshData.asMesh());
										}
									}
								}
const	MDataHandle				meshData(void)
								{	return m_meshData; }

	private:
		sp<SurfaceI>	m_spSurfaceI;

		MDataHandle		m_meshData;
};

} // namespace

#endif /* __maya_SurfaceMaya_h__ */
